import cv2
import numpy as np


kernel3 = np.array([[0, -1,  0],
                   [-1,  5, -1],
                    [0, -1,  0]])

class GmgInit:
    """
    Updated version of GMG bacground segmentation
    """
    def __init__(self):
        self.backgroudSubstractor = cv2.bgsegm.createBackgroundSubtractorGMG()

    def apply(self, frame):
        
        ret_frame = self.backgroudSubstractor.apply(frame)

        return ret_frame

    def set_smooting(self, value):
        self.backgroudSubstractor.setSmoothingRadius(value)


    def process(self, frame): #GMG4
        res = cv2.medianBlur(frame, 7)
        kernel = np.ones((5, 5), np.uint8)
        res = cv2.erode(res, kernel, iterations=1)
        res = cv2.morphologyEx(res, cv2.MORPH_OPEN, kernel)
        return res
    def pre_process(self, frame): #GMG4
        res = frame
        return res

